

import java.awt.Graphics;
import java.awt.Color;


class Turtle {
    Graphics graphics;
    public int x,y,width;
    public int dir;
    double sin,cos;
    public String name;
    public Color color;

    public Turtle(Graphics g) {
	graphics = g;
	x = 0;
	y = 0;
	width = 5;
	name = ".";
	dir = 0;
	sin = 0;
	cos = 1;
	color = Color.black;
    }

    public void move(int dx,int dy) {
	x += dx; y += dy;
    }

    public void draw_move(int dx,int dy) {
	int ox = x;
	int oy = y;
	
	x += dx; y += dy;
	if (color==null) return;
	graphics.drawLine(ox,oy,x,y);
    }

    public void color(Color c) {
	color = c;
	if (c != null) {
	    graphics.setColor(c);
	}
    }

    public void random_color() {
	color(new Color(
	    (int)(java.lang.Math.random()*255),
	    (int)(java.lang.Math.random()*255),
	    (int)(java.lang.Math.random()*255)
	));
    }

    public int x() {
	return x;
    }

    public int x(int newx) {
	int ox;
	ox = x; x = newx;
	return ox;
    }

    public int y() {
	return y;
    }

    public int y(int newy) {
	int oy;
	oy = y; y = newy;
	return oy;
    }

    public void name(String n) {
	name = n;
    }

    public void width(int w) {
	width = w;
	// do nothing...
    }

    public void erase() {
	graphics.clearRect(0,0,400,300);
    }

    public void direction(int d) {
	dir = d % 360;
	if (dir<0) dir +=360;
	if (dir==0) {
	    sin = 0; cos=1;
	} else if (dir==90) {
	    sin = 1; cos=0;
	} else if (dir==180) {
	    sin = 0; cos=-1;
	} else if (dir==270) {
	    sin = -1; cos=0;
	} else {
	    sin = Math.sin(d*(2*Math.PI/360.0));
	    cos = Math.cos(d*(2*Math.PI/360.0));
	}
    }

    public void turn(int turn) {
	direction(dir+turn);
    }

    public void left() {
	direction(dir-90);
    }

    public void right() {
	direction(dir+90);
    }

    public void forward(int length) {
	if (dir==0) {
	    draw_move(length,0);
	} else if (dir==90) {
	    draw_move(0,length);
	    sin = 1; cos=0;
	} else if (dir==180) {
	    draw_move(-length,0);
	    sin = 0; cos=-1;
	} else if (dir==270) {
	    draw_move(0,-length);
	} else {
	    draw_move((int)(cos*length),(int)(sin*length));
	}
    }
}

